import { Player, world } from "mojang-minecraft";
import { ModalFormData, ActionFormData, MessageFormData } from 'mojang-minecraft-ui';
import { Location, BlockLocation } from "mojang-minecraft";

const getScore = (objective, target, useZero = false) => {
        try {
            const obj = world.scoreboard.getObjective(objective);
              if (typeof target == 'string')
                  return obj.getScore(obj.getParticipants().find(v => v.displayName == target));
                  return obj.getScore(target.scoreboard);
          } catch {
              return useZero ? 0 : NaN;
        }
}
const players = [...world.getPlayers()]
let names = players.map(player => player.name)
let gui;




world.events.tick.subscribe(() => {
    for (const player of [...world.getPlayers()]) {
        if (player.hasTag(`bankomatMenu`)) {
            player.runCommand(`tag @s remove bankomatMenu`);
            return main(player);
        }
    }
});




function main(player) {
	gui = new ActionFormData();
	gui.title("§l§2БАНКОМАТ");
	gui.button("§lПеревести");
	gui.button("§lОбналичить");
	gui.button("§lПоложить");
	gui.show(player).then(result => {
		if (result.selection === 0) {
		    return pay(player);
		}
		if (result.selection === 1) {
		    return outup(player);
		}
		if (result.selection === 2) {
		    return getup(player);
		}
	})
}
function pay(player) {
    const balance = getScore("balance", player, true);
    let names = players.map(player => player.name);
    gui = new ModalFormData();
	gui.title("§l§2ПЕРЕВОДЫ");
	gui.slider("Сколько перевести?", 0, balance, 1);
	gui.dropdown("§lКому?", names);
	gui.textField("§lКомментарий", "§eНаписать тут");
	gui.show(player).then(result => {
	    const playerIndex = result.formValues[1];
	    const Host = [...world.getPlayers()].find(plr => plr.name === players[playerIndex].name);
	    let comment = result.formValues[2]

	    if (result.formValues[2] === '') comment = "§7Пусто"
	    if (result.formValues[0] != 0) {
        	player.runCommand(`playsound bankomat.button @s`);
        	player.runCommand(`playsound bankomat.moneysend ${Host.nameTag}`);
        	player.runCommand(`scoreboard players remove @s balance ${result.formValues[0]}`);
        	player.runCommand(`scoreboard players add ${Host.nameTag} balance ${result.formValues[0]}`);
        	player.runCommand(`tellraw @s {"rawtext":[{"text":"§l§aВы перевели §e${result.formValues[0]}р §aигроку §2${Host.nameTag}\n§l§eКомментарий: §7${comment}"}]}`);
        	player.runCommand(`tellraw ${Host.nameTag} {"rawtext":[{"text":"§l§aИгрок §2${player.nameTag} §r§l§aперевел вам §e${result.formValues[0]}р\n§l§eКомментарий: §7${comment}"}]}`)
	    } else {
        	player.runCommand(`tellraw @s {"rawtext":[{"text":"§l§cВы не можете перечислить 0р"}]}`)
	    }
	})
}

function outup(player) {
    const balance = getScore("balance", player, true);
    gui = new ModalFormData();
	gui.title("§l§2СНЯТИЕ НАЛИЧНЫХ");
	gui.slider("Сколько вывести?", 0, balance, 1);
	gui.show(player).then(result => {

	    let outpay = result.formValues[0]
	    if (result.formValues[0] != 0) {
        	player.runCommand(`playsound bankomat.moneysh @s`);
        	player.runCommand(`scoreboard players remove @s balance ${result.formValues[0]}`);
        	player.runCommand(`tellraw @s {"rawtext":[{"text":"§l§aВы обналичили §e${result.formValues[0]}р. §aНа карте осталось §e${balance - result.formValues[0]}р"}]}`);
    
        	for (let i of [5000,2000,1000,500,200,100,50,10,5,2,1]) {
        	    while (outpay >= i) {
                	outpay -= i
                	player.runCommand(`give @s mdz:pyb_${i}`)
            	}
        	}
	    } else {
	        player.runCommand(`tellraw @s {"rawtext":[{"text":"§l§cВы не можете снять 0р"}]}`)
	    }
	})
}

function getup(player) {
    let count = 0
    const balance = getScore("balance", player, true);
    let container = player.getComponent('inventory').container;
    for (let i = 0; i < container.size; i++) {
        if (container.getItem(i)) {
            let item = container.getItem(i);
            if (["mdz:pyb_1", "mdz:pyb_2", "mdz:pyb_5", "mdz:pyb_10", "mdz:pyb_50", "mdz:pyb_100", "mdz:pyb_200", "mdz:pyb_500", "mdz:pyb_1000", "mdz:pyb_2000", "mdz:pyb_5000"].includes(item.id)) {
                count += item.amount * item.id.substr(8, 11);
            }
        }
    }

    gui = new ModalFormData();
	gui.title("§l§2ПОЛОЖИТЬ НА КАРТУ");
	gui.slider("Сколько положить?", 0, count, 1);
	gui.show(player).then(result => {

	    let getpay = count - result.formValues[0]

	    if (result.formValues[0] != 0) {
        	player.runCommand(`playsound bankomat.moneysend @s`);
        	player.runCommand(`tellraw @s {"rawtext":[{"text":"§l§aВы положили на счëт §e${result.formValues[0]}р. §aНа вашей карте теперь §e${balance + result.formValues[0]}р"}]}`);
        	player.runCommand(`scoreboard players add @s balance ${result.formValues[0]}`);
        	for (let i of [5000,2000,1000,500,200,100,50,10,5,2,1]) {
        	    try {
        	        player.runCommand(`clear @s mdz:pyb_${i}`)
        	    } catch (err) {
        	        continue
        	    }
        	}
    
        	player.runCommand(`tellraw @s {"rawtext":[{"text":"§l§aВам выдали сдачу в размере §e${getpay}р"}]}`);
    
        	for (let i of [5000,2000,1000,500,200,100,50,10,5,2,1]) {
        	    while (getpay >= i) {
                	getpay -= i
                	player.runCommand(`give @s mdz:pyb_${i}`)
            	}
        	}
	    } else {
        	player.runCommand(`tellraw @s {"rawtext":[{"text":"§l§cВы не можете положить 0р"}]}`)
	    }
	})
}